#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "datatypes.h"
#include "print.h"
#include "tools.h"


/*************************ASY{******************************/

// pointer ̕tւ@O(1)	̖؂傫ق̖؂̍ւȂ
void merge (MFSet *set0, MFSet *set1) {
  if (set0 == set1 || set0 == NULL || set1 == NULL)
    return;
  if (set0->size > set1->size){
    set1->root->parent = set0->root;
    set0->size += set1->size;
  }
  else {
    set0->root->parent = set1->root;
    set1->size += set0->size;
  }	
}

// ؂̂ڂ@O(log n);		// oḦk͖
MFSet *find (MFSetNode *node) {
  if (node == NULL) return NULL;
  while(node->parent != NULL){
    node = node->parent;
  }
  return node->set;
}

/*************************ASY{̂܂******************************/


int main (int argc, char *argv[]) {
  if (argc != 2) {
    printf("g: %s maxvalue(}鐮̍ől)\n", argv[0]);
    return 0;
  }

  char command;
  char fname[1024] = {0};
  MFSet* sets[256];
  MFSetNode **val_to_node;
  char setname0, setname1;
  int val, i, s;
  s = atoi(argv[1]) + 1;


  fprintf(stderr, "**********WQ**********\n");
  fprintf(stderr, "R}hF\n");
  fprintf(stderr, "i [n] [s] : 񕉐nWsɑ}(sASCII1)\n");
  fprintf(stderr, "m [s1] [s2] : Ws1s2Merge\n");
  fprintf(stderr, "f [n] : n̑W\(find)\n");
  fprintf(stderr, "p : WQŜ̓e\\n");
  fprintf(stderr, "ӁF\n");
  fprintf(stderr, "}f[^͔񕉐ł邱ƁB\n");
  fprintf(stderr, "ȂAdf[^}ꍇ͖̓`ł\n");
  fprintf(stderr, "*************************\n");


  val_to_node = malloc(s * sizeof(MFSetNode*));

  for (i = 0; i < 256; ++i) sets[i] = NULL;
  for (i = 0; i < s; ++i) val_to_node[i] = NULL;

  while (scanf(" %c", &command) != EOF) {
    switch (command) {
    case 'i':
      scanf("%d", &val);
      scanf(" %c", &setname0);
      MFSet *set;
      MFSetNode *node = malloc(sizeof(MFSetNode));
      node->children = malloc((s + 1) * sizeof(MFSetNode*)); // For printing.
      node->val = val;
      val_to_node[val] = node;
      if (sets[(int)setname0] == NULL) {
	// Generate new set
	set = malloc(sizeof(MFSet));
	sets[(int)setname0] = set;
	set->size = 1;
	node->parent = NULL;
	node->set = set;
	set->root = node;
      }
      else {
	set = sets[(int)setname0];
	++(set->size);
	node->parent = set->root;
      }
      break;
    case 'm':
      scanf(" %c", &setname0);
      scanf(" %c", &setname1);
      MFSet *set0 = sets[(int)setname0], *set1 = sets[(int)setname1];
      merge(set0, set1);
      if (set0 == NULL ||  set1 == NULL) continue;
      if (set0->size > set1->size) {
	free(set1);
	sets[(int)setname1] = NULL;
      }
      else {
	free(set0);
	sets[(int)setname0] = NULL;
      }
      break;
    case 'f':
      scanf("%d", &val);
      // check
      if (val < 0) {
	printErrMessage("Invalid value", "Negative number.");
	continue;
      }
      MFSetNode *n = val_to_node[val];
      MFSet *found = find(n);
      if (found == NULL) {
	printf ("Not Found.\n");
      }
      else {
	for (i = 0; i < 256; ++i) {
	  if (sets[i] == found) {
	    printf ("Found: %d\n", i);
	    break;
	  }
	}
      }
      break;
    case 'p':

      printMFSets("MergeFindSets", sets, val_to_node, s, NULL, NULL);
      break;
    default:
      break;
    }
  }

  for (i = 0; i < s; ++i) {
    if (val_to_node[i] != NULL) {
      free(val_to_node[i]->children);
      free(val_to_node[i]);
    }
  }
  for (i = 0; i < 256; ++i)
    free(sets[i]);
  free(val_to_node);

  return 0;
}
